<template>
  <el-dialog width="80%" :title="`${title}单位`" :visible="visible" :before-close="handleClose" v-if="visible">
    <el-form ref="formInfo" :rules="rules" :model="params" label-width="120px">
      <el-row>
        <el-col :span="8">
          <el-form-item prop="companyName" label="单位名称">
            <el-input maxlength="128" placeholder="请输入单位名称" v-model="params.companyName"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item prop="companyShortName" label="单位简称">
            <el-input maxlength="32" placeholder="请输入单位简称" v-model="params.companyShortName">
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item prop="companyCode" label="单位编码">
            <el-input maxlength="32" placeholder="请输入单位编码" v-model="params.companyCode"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="16">
          <el-form-item prop="companyTypeShow" label="单位类型" class="company-type">
            <el-checkbox-group v-model="params.companyTypeShow" @change="changeType">
              <el-checkbox v-for="item in companyType" :key="item.value" :label="item.value">
                {{ item.name }}
              </el-checkbox>
            </el-checkbox-group>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="8">
          <el-form-item prop="companyMan" label="联系人">
            <el-input maxlength="32" placeholder="请输入联系人" v-model="params.companyMan"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="联系电话" prop="companyTel">
            <el-input maxlength="18" placeholder="请输入联系电话" v-model.number="params.companyTel"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item prop="companyMail" label="单位邮箱">
            <el-input maxlength="64" @input="e=>clearBlank(e, 'companyMail')" placeholder="请输入单位邮箱"
              v-model="params.companyMail"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="8">
          <el-form-item prop="companyFax" label="单位传真">
            <el-input maxlength="32" @input="e =>clearBlank(e, 'companyFax')" placeholder="请输入单位传真"
              v-model="params.companyFax"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="16">
          <el-form-item label="单位地址" prop="companyAddress">
            <el-input maxlength="256" placeholder="请输入单位地址" v-model="params.companyAddress">
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="备注" prop="memo">
        <el-input show-word-limit maxlength="500" type="textarea" :autosize="{ minRows: 3, maxRows: 4 }"
          placeholder="请输入备注内容" v-model="params.memo">
        </el-input>
      </el-form-item>
      <!-- </el-collapse-item>
      <el-collapse-item name="2" v-show="extendParams.length">
        <template slot="title">
          <span class="collapse-title">
            <i class="collapse-title-icon el-icon-circle-plus"></i>
            单位扩展信息
          </span>
        </template>
<el-row type="flex" justify="start" style="flex-wrap: wrap; flex-direction: row">
  <el-col :span="extendParam.layout" v-for="extendParam in extendParams" :key="extendParam.id">
    <el-form-item :prop="
                                  extendRuleNames[`$extend${extendParam.id}`]
                              " :label="extendParam.name">
      <el-input v-if="extendParam.ctlType == 'input'" :placeholder="`请输入${extendParam.name}`"
        v-model="params[`$extend${extendParam.id}`]"></el-input>
      <el-input v-if="extendParam.ctlType == 'number'" :min="0" type="number" :placeholder="`请输入${extendParam.name}`"
        v-model.number="
                                      params[`$extend${extendParam.id}`]
                                  "></el-input>
      <el-radio-group v-if="extendParam.ctlType == 'radio'" :placeholder="`请选择${extendParam.name}`"
        v-model="params[`$extend${extendParam.id}`]">
        <template v-if="extendParam.json">
                  <el-radio v-for="item in JSON.parse(
                                              extendParam.json
                                          )" :key="item.value" :label="item.value">{{ item.label }}
                  </el-radio>
                </template>
      </el-radio-group>
      <el-checkbox-group v-if="
                                      extendParam.ctlType == 'checkbox' &&
                                      extendParam.json
                                  " :placeholder="`请选择${extendParam.name}`"
        v-model="params[`$extend${extendParam.id}`]">
        <el-checkbox v-for="item in JSON.parse(
                                          extendParam.json
                                      )" :key="item.value" :label="item.value">{{ item.label }}
        </el-checkbox>
      </el-checkbox-group>
      <el-select v-if="extendParam.ctlType == 'select'" :placeholder="`请选择${extendParam.name}`"
        v-model="params[`$extend${extendParam.id}`]">
        <template v-if="extendParam.json">
                  <el-option v-for="item in JSON.parse(
                                              extendParam.json
                                          )" :key="item.value" :label="item.label" :value="item.value">
                  </el-option>
                </template>
      </el-select>
      <el-date-picker v-if="extendParam.ctlType == 'date'" :placeholder="`请选择${extendParam.name}`"
        v-model="params[`$extend${extendParam.id}`]" value-format="yyyy-MM-dd">
      </el-date-picker>
    </el-form-item>
  </el-col>
</el-row>
</el-collapse-item>
</el-collapse> -->
    </el-form>
    <span slot="footer" class="dialog-footer">
      <el-button type="primary" @click="handleSave">保 存</el-button>
      <el-button @click="handleClose">取 消</el-button>
    </span>
  </el-dialog>
</template>
<script>
import resourceManage from '@/api/device/resourceManage.js'
import utils from '@/hotent-ui-util.js'
import dictUtils from '@/components/dict/DictSelectUtils.js'
import {
  ExtendParamsMixin
} from '@/mixins/extendParams.js'

export default {
  name: 'unitManageModal',
  mixins: [ExtendParamsMixin],
  data() {
    var checkPhone = (rule, value, callback) => {
      let moblie = /^1([3456789])\d{9}$/ // 手机
      let tel = /^([2-9][0-9]{4,7})+(-[0-9]{1,4})?$/ //座机
      if (!moblie.test(value) && !tel.test(value)) {
        callback(new Error('联系电话不合规则'))
      } else {
        callback()
      }
    }

    const validateEmail = (rule, value, callback) => {
      if (!value) {
        return callback()
      } else {
        const emailPattern = /^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9-]+\.[a-zA-Z0-9-.]+$/
        if (!emailPattern.test(value)) {
          return callback(new Error('邮箱地址不合法'))
        } else {
          return callback()
        }
      }

    }

    const validateCompanyFax = (rule, value, callback) => {
      if (!value) {
        return callback()
      } else {
        const faxPattern = /^\+?[0-9\s]{7,15}$/
        if (!faxPattern.test(value)) {
          return callback(new Error('传真号码不合法'))
        } else {
          return callback()
        }
      }
    }

    return {
      visible: false,
      title: '新增',
      activeCollapse: '1',
      params: {
        companyAddress: '',
        companyCode: '',
        companyFax: '',
        companyMail: '',
        companyMan: '',
        companyName: '',
        companyShortName: '',
        companyTel: '',
        companyTypeShow: ['1'],
        companyType: '',
        memo: ''
      },
      companyType: [], //单位类型
      rules: {
        companyName: [{
          required: true,
          message: '请输入单位名称',
          trigger: 'change'
        }],
        companyShortName: [{
          required: true,
          message: '请输入单位简称',
          trigger: 'change'
        }],
        companyCode: [{
          required: true,
          message: '请输入单位编码',
          trigger: 'change'
        }],
        companyTypeShow: [{
          required: true,
          message: '请选择单位类型',
          trigger: 'change'
        }],
        companyTel: [{
          required: true,
          message: '请输入联系电话',
          trigger: 'blur'
        }, {
          validator: checkPhone,
          trigger: 'blur'
        }],
        companyMail: [
          {
            required: false,
            message: '请输入单位邮箱',
            trigger: 'blur'
          },
          {
            validator: validateEmail,
            trigger: ['blur', 'change']
          }
        ],
        companyFax: [
          {
            required: false,
            message: '请输入单位传真',
            trigger: 'blur'
          },
          {
            validator: validateCompanyFax,
            trigger: ['blur', 'change']
          }
        ],
        memo: [{
          message: '请选择单位类型',
          max: 500,
          trigger: 'change'
        }]
      }
    }
  },
  async created() {
    this.companyType = dictUtils.getDictItemsFromCache('dwlx')
    await this.getExtendParams(1)
  },
  methods: {
    clearBlank(e, type) {
      console.log(e, type);
      this.params[type] = e.replace(/\s+/g,"")
    },
    changeType() {
      this.$forceUpdate()
    },
    add() {
      // 扩展字段混入到表单绑定数据中
      // this.handleExtendParamsMixin()
      this.visible = true
    },
    edit(row) {
      console.log(row)
      this.params = utils.deepClone(row)
      this.params.companyTypeShow = this.params.companyType ?
        this.params.companyType.split(',') :
        ['1']
      // 获取扩展字段值
      // await this.getExtendParamsData(1, this.params.id)
      // 扩展字段混入到表单绑定数据中
      // this.handleExtendParamsMixin()
      this.visible = true
      this.title = '修改'
    },
    handleClose() {
      this.params = {
        companyAddress: '',
        companyCode: '',
        companyFax: '',
        companyMail: '',
        companyMan: '',
        companyName: '',
        companyShortName: '',
        companyTel: '',
        companyTypeShow: ['1'],
        companyType: '',
        memo: ''
      }
      this.title = '新增'
      this.activeCollapse = '1'
      this.visible = false
    },
    handleSave() {
      this.$refs.formInfo.validate((valid) => {
        if (valid) {
          let tempData = utils.deepClone(this.params)
          tempData.companyType = tempData.companyTypeShow?.length ?
            tempData.companyTypeShow.join(',') :
            ''
          tempData.companyTypeShow && delete tempData.companyTypeShow
          // 扩展字段提交前预处理数据
          tempData = this.handleExtendParamsSave(tempData, '1')
          let method
          if (this.title === '新增') {
            method = resourceManage.addUnit
            // console.log('新增')
          } else if (this.title === '修改') {
            method = resourceManage.editUnit
            // console.log('修改')
          }
          // console.log(tempData, 'tempData')
          method(tempData, (response) => {
            if (response.state) {
              this.$notify({
                type: 'success',
                message: this.title + '成功',
                duration: 2000
              })
              this.handleClose()
              this.$parent.loadData(1)
            } else {
              this.$message.warning(response.message)
            }
          })
        } else {
          this.$notify({
            type: 'warning',
            message: '请完善表单信息！',
            duration: 2000
          })
        }
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.company-type ::v-deep .el-checkbox-group {
  height: initial !important;
}
</style>
